#!/bin/bash
TMP_DIR="/tmp/sdk-publisher/tmp"
HOME_DIR="$(pwd)"

SHOW_PLATFORMS=true
SHOW_SDK=false
SHOW_EXPECTED_VERSION=false

__print_usage () {
    echo "Command line arguments are as follows:"
    echo "-h, --help              : Print this help message"
    echo "-s, --sdk {name}        : Add column for sdk pipeline status (needs name)"
    echo "-f, --file {file.csv}   : Specify the project list csv to load"
    echo ""
    echo "typical use:"
    echo "./update-ci-status-page.sh -f sdk_csvs/sdk-1.1.0.csv"
    echo
}


__parse_opts(){

    while [[ $# -gt 0 ]]; do
        case $1 in
            -h|--help)
                # Make sure we don't purge the relics on a false run
                __print_usage
                exit 0
                ;;
            -s|--sdk)
                if ! [[ $# -gt 1 ]] ; then
                    echo "sdk flag needs an option"
                    exit 1
                fi
                SHOW_SDK=true
                SDK_NAME=$2
                SDK_CLEAN="$( echo $SDK_NAME | tr '-' ' ' | tr '[:lower:]' '[:upper:]' )"
                shift
                ;;
            -f|--file)
                if ! [[ $# -gt 1 ]] ; then
                    echo "file option needs an option"
                    exit 1
                fi
                FILE_NAME=$2
                shift
                ;;
            *)
                # Make sure we don't purge the relics on a false run
                echo "Unknown argument $1"
                __print_usage
                exit 1
                ;;
        esac
        shift
    done

    if [ "${FILE_NAME}" == "" ]; then
        echo "please provide a file name"
        __print_usage
        exit 1
    fi
}

__update_ci_status_page_main() {

    __parse_opts $@

    if ! [ -f ${FILE_NAME} ]; then
        echo "ERROR: Missing ${FILE_NAME}, make sure this file is available and has the latest CSV from the spreadsheet"
        exit 1
    fi

    mkdir -p $TMP_DIR

    cd $TMP_DIR

    [ -d ci-status ] && rm -rf ci-status

    git clone git@gitlab.com:voxl-public/voxl-sdk/ci-status.git

    ! [ -d ci-status ] && echo "ERROR Cloning Project" && return -1

    cd $HOME_DIR

    # 1. cat the project csv
    # 2. translate the semicolons to newlines
    # 3. grab the third field (subfolder)
    # 4. sort them alphabetically
    # 5. remove repeat lines
    # 6. remove empty lines
    FOLDER_LIST=( $( cat ${FILE_NAME} | tr ';' '\n' | cut -d ',' -f 3 | sort | uniq | sed '/^[[:space:]]*$/d' ) )

    local FILE="${TMP_DIR}/ci-status/README.md"

    echo "# CI Status" > $FILE
    echo "This file has been autogenerated, please do not modify. The script used to generate it can be found [here](https://gitlab.com/voxl-public/voxl-sdk/publishing-tools/-/blob/master/sdk-tools/update-ci-status-page.sh)" >> $FILE
    echo >> $FILE

    for FOLDER in ${FOLDER_LIST[@]} ; do

        local FOLDER_PRINT=$( echo ${FOLDER} | tr '-' ' ' | sed -e "s/\b\(.\)/\u\1/g" )
        PROJECT_LIST=( $( cat ${FILE_NAME} | tr ';' '\n'  | sort | grep $FOLDER ) )

        echo "## [${FOLDER_PRINT}](https://gitlab.com/voxl-public/voxl-sdk/${FOLDER})" >> $FILE
        echo ""                              >> $FILE
        echo "<table>"                       >> $FILE
        echo ""                              >> $FILE
        echo "  <tr>"                        >> $FILE
        echo "    <th>Project</th>"          >> $FILE
        echo "    <th>Current Version</th>"  >> $FILE
        if $SHOW_EXPECTED_VERSION; then
            echo "    <th>Expected Version</th>" >> $FILE
        fi
        if $SHOW_SDK ; then
            echo "    <th>${SDK_CLEAN}</th>"  >> $FILE
        fi
        echo "    <th>Master</th>"           >> $FILE
        echo "    <th>Dev</th>"              >> $FILE
        if $SHOW_PLATFORMS ; then
            echo "    <th>APQ8096</th>"      >> $FILE
            echo "    <th>QRB5165</th>"      >> $FILE
        fi
        echo "  </tr>"                       >> $FILE

        for PROJECT_LINE in ${PROJECT_LIST[@]} ; do

            PROJ_NAME=$(echo ${PROJECT_LINE} | cut -d ',' -f 1)
            PROJ_VER=$(echo ${PROJECT_LINE}  | cut -d ',' -f 2)
            PROJ_DIR=$(echo ${PROJECT_LINE}  | cut -d ',' -f 3)
            PROJ_APQ=$(echo ${PROJECT_LINE}  | cut -d ',' -f 4)
            PROJ_QRB=$(echo ${PROJECT_LINE}  | cut -d ',' -f 5)

            ## used to skip these, but now we have optional packages that are not in voxl-suite that
            ## we still want to monitor and audit
            # if [ $PROJ_APQ == "FALSE" ] && [ $PROJ_QRB == "FALSE" ] ; then
            #     continue
            # fi

            echo                         >> $FILE
            echo "  <!-- $PROJ_NAME -->" >> $FILE
            echo "  <tr>"                >> $FILE
            echo "    <!-- Repo -->"     >> $FILE
            echo "    <td>"              >> $FILE
            echo "     [${PROJ_NAME}](https://gitlab.com/voxl-public/voxl-sdk/${FOLDER}/${PROJ_NAME})" >> $FILE
            echo "    </td>"             >> $FILE
            echo "    <!-- Release Version -->"   >> $FILE
            echo "    <td>"              >> $FILE
            echo "     <a href=\"https://gitlab.com/voxl-public/voxl-sdk/${FOLDER}/${PROJ_NAME}/-/releases\">" >> $FILE
            echo "       <img alt=\"Latest Release\" src=\"https://gitlab.com/voxl-public/voxl-sdk/${FOLDER}/${PROJ_NAME}/-/badges/release.svg?key_text=Release&key_width=65\" />" >>$FILE
            echo "     </a>"             >> $FILE
            echo "    </td>"             >> $FILE
            if $SHOW_EXPECTED_VERSION; then
                echo "    <!-- Release Pipeline -->"   >> $FILE
                echo "    <td>"              >> $FILE
                echo "     <a href=\"https://gitlab.com/voxl-public/voxl-sdk/${FOLDER}/${PROJ_NAME}/-/pipelines/v${PROJ_VER}/latest\">" >> $FILE
                echo "       <img alt=\"pipeline status\" src=\"https://gitlab.com/voxl-public/voxl-sdk/${FOLDER}/${PROJ_NAME}/badges/v${PROJ_VER}/pipeline.svg?key_text=v${PROJ_VER}&key_width=60&ignore_skipped=true\" />" >>$FILE
                echo "     </a>"             >> $FILE
                echo "    </td>"             >> $FILE
            fi
            if $SHOW_SDK ; then
                echo "    <!-- SDK Pipeline -->"   >> $FILE
                echo "    <td>"              >> $FILE
                echo "     <a href=\"https://gitlab.com/voxl-public/voxl-sdk/${FOLDER}/${PROJ_NAME}/-/pipelines/${SDK_NAME}/latest\">" >> $FILE
                echo "       <img alt=\"pipeline status\" src=\"https://gitlab.com/voxl-public/voxl-sdk/${FOLDER}/${PROJ_NAME}/badges/${SDK_NAME}/pipeline.svg?key_text=${SDK_CLEAN}&key_width=60&ignore_skipped=true\" />" >>$FILE
                echo "     </a>"             >> $FILE
                echo "    </td>"             >> $FILE
            fi
            echo "    <!-- Master -->"   >> $FILE
            echo "    <td>"              >> $FILE
            echo "     <a href=\"https://gitlab.com/voxl-public/voxl-sdk/${FOLDER}/${PROJ_NAME}/-/pipelines/master/latest\">" >> $FILE
            echo "       <img alt=\"pipeline status\" src=\"https://gitlab.com/voxl-public/voxl-sdk/${FOLDER}/${PROJ_NAME}/badges/master/pipeline.svg?key_text=Master+Pipeline&key_width=100&ignore_skipped=true\" />" >>$FILE
            echo "     </a>"             >> $FILE
            echo "    </td>"             >> $FILE
            echo "    <!-- Dev -->"      >> $FILE
            echo "    <td>"              >> $FILE
            echo "     <a href=\"https://gitlab.com/voxl-public/voxl-sdk/${FOLDER}/${PROJ_NAME}/-/pipelines/dev/latest\">" >> $FILE
            echo "       <img alt=\"pipeline status\" src=\"https://gitlab.com/voxl-public/voxl-sdk/${FOLDER}/${PROJ_NAME}/badges/dev/pipeline.svg?key_text=Dev+Pipeline&key_width=85&ignore_skipped=true\" />" >>$FILE
            echo "     </a>"             >> $FILE
            echo "    </td>"             >> $FILE
            if $SHOW_PLATFORMS ; then
                echo "    <!-- APQ8096 -->"  >> $FILE
                echo "    <td>"              >> $FILE
                if [ $PROJ_APQ == "TRUE" ] ; then
                    echo "     :heavy_check_mark:" >> $FILE
                fi
                echo "    </td>"             >> $FILE
                echo "    <!-- QRB5165 -->"  >> $FILE
                echo "    <td>"              >> $FILE
                if [ $PROJ_QRB == "TRUE" ] ; then
                    echo "     :heavy_check_mark:" >> $FILE
                fi
                echo "    </td>"             >> $FILE
                echo "  </tr>"               >> $FILE
            fi

        done

        echo "</table>" >> $FILE
        echo >> $FILE

    done

    cd "${TMP_DIR}/ci-status"

    git commit -am "update README"
    git push

    echo ""
    echo "go check out the result here:"
    echo "https://gitlab.com/voxl-public/voxl-sdk/ci-status"
    echo ""

}

__update_ci_status_page_main "$@"
